module;

#include <exception>
#include <algorithm>
#include <codecvt>
#include <locale>
#include <ranges>
#include <source_location>
#include <string>
#include <vector>
#include <fmt/core.h>

module com.threedbb.ulog;

std::string toUTF8(const std::u16string &str) {
    std::wstring_convert<std::codecvt_utf8_utf16<char16_t>, char16_t> convert;
    return convert.to_bytes(str);
}

void LTHROW(const std::string &msg, const std::source_location &loc) {
    throw std::runtime_error(asLogFormat("THROW",msg,loc));
}

std::string asLogFormat(const std::string &level, const std::string &msg, const std::source_location &loc) {
    return fmt::format("{}:{}:{}:{}:{}",
                       level,
                       loc.file_name(),
                       loc.line(),
                       loc.function_name(),
                       msg);
}
